#define __PROG_TYPES_COMPAT__

#include "BMP180.h"
#include "lcd.h"
#include "gfx.h"
#include "dht.h"

#include <avr/pgmspace.h>
#include <avr/io.h>

#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>

int main(void)
{
	char printbuff[100];
	float temperature = 0;
	float humidity = 0;
	long pressure;
	double temp2, alt;
	
	LCD_init();
	GFX_init(128, 160);
	
	GFX_set_text_size(1);
	GFX_set_rotation(0);
	GFX_set_text_color(TFT141_YELLOW);
	
	LCD_fill_screen(TFT141_BLACK);
	GFX_set_cursor(10, 88);
	GFX_print_str("Initializing...");
	BMP180_init();
	
	for (;;) {		
		if (dht_gettemperaturehumidity(&temperature, &humidity) != -1) {

			dtostrf(temperature, 3, 1, printbuff);
	
			LCD_fill_screen(TFT141_BLACK);
			GFX_set_cursor(10, 32);
			GFX_print_str("temp: ");
			GFX_print_str(printbuff);
			GFX_print_str("C");
			
			dtostrf(humidity, 3, 1, printbuff);
			
			GFX_set_cursor(10, 56);
			GFX_print_str("hum: ");
			GFX_print_str(printbuff);
			GFX_print_str("%RH");
			
			temp2 = BMP180_gettemperature();
			alt = BMP180_getaltitude();
			pressure = BMP180_getpressure();
			
			dtostrf(temp2, 3, 1, printbuff);
			GFX_set_cursor(10, 80);
			GFX_print_str("temp2: ");
			GFX_print_str(printbuff);
			GFX_print_str("C");
			
			dtostrf(alt, 3, 1, printbuff);
			GFX_set_cursor(10, 104);
			GFX_print_str("alt: ");
			GFX_print_str(printbuff);
			GFX_print_str("m");
			
			ltoa(pressure, printbuff, 10);
			
			GFX_set_cursor(10, 128);
			GFX_print_str("pressure: ");
			GFX_print_str(printbuff);
			GFX_print_str("Pa");
		}
		_delay_ms(1500);
	}
	LCD_end();

	return 0;
}
